#include <AFMotor.h>
#include <Servo.h> 

Servo servo1;
Servo servo2;

AF_DCMotor motor1(1, MOTOR12_64KHZ);
AF_DCMotor motor2(2, MOTOR12_64KHZ);
int microAngleAdjust = -10;
int angle = 30;
int currentAngle = 90 + microAngleAdjust;
int sensorValue = 0;
int ii = 0;
boolean excute = false;
int delayTime = 200;
const int sensorPin = A0;
const int ledPin =  10;

void setup() {
  Serial.begin(9600);
  Serial.println("Motor start!");
  
  servo1.attach(9);
  servo2.attach(10);
  
  motor1.setSpeed(200);
  motor2.setSpeed(200);
  
  MoveForward ();
}

void loop() {
  scanRange();
}

void scanRange(){
  
  if(currentAngle>=120+microAngleAdjust){
    angle = -30;
    //currentAngle=0;
  }
  if(currentAngle<=60+microAngleAdjust){
    angle=30;
  }
  servo1.write(currentAngle);
  currentAngle=currentAngle+angle;
  
  Serial.print("currentAngle:");
  Serial.print(currentAngle);
  
  sensorValue = read_gp2d12_range(sensorPin);
  Serial.print("    sensorValue:");
  Serial.println(sensorValue);
  delay(delayTime);
  
  if(sensorValue<18 && sensorValue>1){
    excute=true;
    if(excute == true){
      if(currentAngle>=120+microAngleAdjust){
        MoveLeft();
      }else if(currentAngle<=60+microAngleAdjust){
        MoveRight();
      }else{
        MoveBackward();
      }
    }
  }else{
    if(excute == true){
      MoveForward ();
    }
  }
  
}



void MoveForward (){
  motor1.run(FORWARD);
  motor2.run(BACKWARD);
  Serial.println("Forward");
  delay(delayTime);
  excute = false;
}
void MoveBackward (){
  motor1.run(BACKWARD);
  motor2.run(FORWARD);
  delay(delayTime*5);
  Serial.println("Backward");
}
void MoveLeft (){
  motor1.run(FORWARD);
  motor2.run(FORWARD);
  delay(delayTime*2);
  Serial.println("Left");
}
void MoveRight (){
  motor1.run(BACKWARD);
  motor2.run(BACKWARD);
  delay(delayTime*2);
  Serial.println("Right");
}
void MoveLeftBit (){
  motor1.run(RELEASE);
  motor2.run(FORWARD);
  delay(delayTime*1);
  Serial.println("Left");
}
void MoveRightBit (){
  motor1.run(BACKWARD);
  motor2.run(RELEASE);
  delay(delayTime*1);
  Serial.println("Right");
}
void StopMove (){
  motor1.run(RELEASE);
  motor2.run(RELEASE);
  excute = false;
}

float read_gp2d12_range(byte pin) {
	int tmp;

	tmp = analogRead(pin);
	if (tmp < 3)
		return -1; // invalid value

	return int((6787.0 /((float)tmp - 3.0)) - 4.0);
} 
  
